﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'v1.00
Sub Class_Globals
	Private Const FLAG_GRANT_READ_URI_PERMISSION As Int=1
	Private Const BROADCAST_TARGET_PACKAGE_NAME As String="b4a.example.receiveintent"
	
	Private Context As JavaObject
	Private fp As JavaObject
	Public SharedFolder As String
End Sub

Public Sub Initialize
	Context.InitializeContext
	fp.InitializeStatic("android.support.v4.content.FileProvider")
	SharedFolder = File.Combine(File.DirInternal, "torrent-files")
	File.MakeDir("", SharedFolder)
End Sub

Public Sub GetFileUri (FileName As String) As Object
	Dim FileToShare As JavaObject
	FileToShare.InitializeNewInstance("java.io.File", Array(SharedFolder, FileName))
	
	Dim FileUri As Object=fp.RunMethod("getUriForFile", Array(Context, Application.PackageName & ".provider", FileToShare))
	
	Context.RunMethod("grantUriPermission", Array As Object(BROADCAST_TARGET_PACKAGE_NAME, FileUri, FLAG_GRANT_READ_URI_PERMISSION))
	
	Return FileUri
End Sub

Public Sub SetFileUriAsIntentData (Intent1 As Intent, FileName As String, MimeType As String)
	Dim jo As JavaObject = Intent1
	jo.RunMethod("setDataAndType", Array As Object(GetFileUri(FileName), MimeType))
	Intent1.Flags = Bit.Or(Intent1.Flags, FLAG_GRANT_READ_URI_PERMISSION)
End Sub